import karamba
import feedparser
import time
from time import time
import string
import jannis
from threading import *
import thread
import os
import re
from urllib import urlopen, quote_plus
from os.path import expanduser
import copy
import textwrap

# CONFIGURATION

global feedNr
global MaxFeeds
global oldFeed
global countTicks
global ScrollThem
global currentTopic
s = 1
debug = 0
url = []
rss_title = None
line = []
currentTopic = 0 
countTicks = 0
ScrollThem=0
feedNr = 1
topicFontSize = 10          # Fontsize for topics - you can change this to make widget taller or shorter
topicFont     = "Bitstream"   # Fontface for topics
numberTopics  = 10         # Number of topics to display
feedURLs      = []
feedNames     = []
MaxFeeds = 2
previewBoxW   = 190      # Width of the preview box
previewBoxH   = 250      # Height of the preview box
previewCols   = 29       # Number of characters per line
previewRows   = 12       # Number of rows for preview
feeds         = []
topicSlots    = []
feedSlots     = []

class Future:
    def __init__(self,func,*param):
        # Constructor
        self.__done=0
        self.__result=None
        self.__status='working'
        self.__excpt=None
        self.__C=Condition()
        self.__T=Thread(target=self.Wrapper,args=(func,param))
        self.__T.setName("FutureThread")
        self.__T.start()

    def __repr__(self):
        return '<Future at '+hex(id(self))+':'+self.__status+'>'

    def isDone(self):
        return self.__done    # Notify if the function is complete

    def __call__(self):
        self.__C.acquire()
        while self.__done==0:
            self.__C.wait()
        self.__C.release()
        if self.__excpt: raise self.__excpt
        a=copy.deepcopy(self.__result)
        return a

    def Wrapper(self, func, param):
        # Run the actual function, and let us housekeep around it
        self.__C.acquire()
        try:
            self.__result=func(*param)
        except Exception, e: # We got an exception object, save it.
            self.__excpt = e
        except:
            self.__result="Exception raised within Future"
        self.__done=1
        self.__status=`self.__result`
        self.__C.notify()
        self.__C.release()

###########  Superkaramba API functions     ################
def initWidget(widget):
	global previewText, feeds, topicSlots, feedSlots, numberTopics, previewCloseImg, previewOpenImg, currentTopic, oldFeed, MaxFeeds, mult, themepath, chunks, s, rss_title
	karamba.resizeWidget(widget, 100, 492);
	lines = []
   	chunks = 0
    	themepath = karamba.getThemePath( widget )
    	karamba.addMenuConfigOption(widget, "newRssItem", "Add a rss source")
    	karamba.addMenuConfigOption(widget, "delRssItem", "Delete a rss source")
    	karamba.setMenuConfigOption(widget, "newRssItem", 0)
    	karamba.setMenuConfigOption(widget, "delRssItem", 0)
  	try:
        	indexFile = open(themepath + 'index.conf', 'r')
		savedS = indexFile.readline ()
		indexFile.close ()
	except IOError:
		savedS = None
	else:
		savedS = None
 	if (savedS == None): s = 0
	else: s = int (savedS)
	conffile = open (themepath + '/url.conf', 'r')
    	while 1:
       		line = conffile.readline()
       		if not line:
            		break
        	elif line.startswith('\n'):
            		continue
        	elif line.startswith('#'):
			continue
        	else:
            		lines.append(line.strip('\n'))
            		chunks = chunks + 1
   	chunks = chunks/2
	n = 0
    	for i in range(0, chunks):
		feedNames.append(lines[n])		
        	n = n + 2
    	n = 1
    	for i in range(0, chunks):
		feedURLs.append(lines[n])		
        	n = n + 2
	MaxFeeds = chunks
	oldFeed = feedNames[0]
	
	currentTopic=0
	oldFeed = karamba.createText(widget, 5, 22, 90, 32, wrap(feedNames[0], 10, 2))
	karamba.setTextAlign(widget, oldFeed, "CENTER")
	karamba.changeTextColor(widget, oldFeed, 150, 0, 0)
	karamba.changeTextSize(widget, oldFeed, 14)
	x = 40
	i=0
	
	# Create preview window
	jannis.createBox(widget, "preview", 110, 62, previewBoxW, previewBoxH, "pixel/box2/", False)
	tmpBox = jannis.getBox(widget, "preview")
	previewText = karamba.createText(widget, (110+tmpBox["imageDim"]["tl"][0]),
									 (62+tmpBox["imageDim"]["tl"][1]+16),
									 (previewBoxW-tmpBox["imageDim"]["tl"][0]-tmpBox["imageDim"]["tr"][0]),
									 (previewBoxH-tmpBox["imageDim"]["tl"][1]-tmpBox["imageDim"]["tr"][1]),
									 '')
	karamba.changeTextColor(widget, previewText, 0,0,0)
	karamba.changeTextSize(widget, previewText, 11)
	previewOpenImg = karamba.createImage(widget, (110+tmpBox["imageDim"]["tl"][0]),
	                                      (62+tmpBox["imageDim"]["tl"][1]), "pixel/network.png")
	previewCloseImg  = karamba.createImage(widget, (110+tmpBox["w"]-tmpBox["imageDim"]["tr"][0]-16),
	                                      (62+tmpBox["imageDim"]["tl"][1]), "pixel/remove.png")
	karamba.attachClickArea(widget, previewOpenImg)
	karamba.attachClickArea(widget, previewCloseImg)
	jannis.hideBox(widget, "preview")
	hidePreviewBox(widget)
	
	# Initialize feeds and topics
	while i < (MaxFeeds):
		feedSlots.append(feedNames[i])
		feeds.append(feed(False, feedURLs[i], feedNames[i]))
		i+=1
	mult = topicFontSize+11
	i = 0;
	while i < numberTopics:
		y = i * 2 * mult + 65
		date = "12.23.4567"
		tmp = karamba.createText(widget, 5, y, 100, mult, "")
		karamba.attachClickArea(widget, tmp)
		topicSlots.append(tmp)
		karamba.changeTextSize(widget, tmp, topicFontSize)
		karamba.changeTextFont(widget, tmp, topicFont)
		karamba.changeTextColor(widget, tmp, 0, 0, 0)
		sprtor = karamba.createText(widget, 6, y + mult + 7 , 100, mult, "____________")
		karamba.changeTextColor(widget, sprtor, 0, 0, 255)
		i+=1
	# Display first feed
	openFeed(widget, 0)

def widgetUpdated(widget):
	global currentTopic, countTicks, ScrollThem, numberTopics, feedNr
	countTicks +=1
	fourticks = countTicks * .25
	#if fourticks == int(fourticks):
	#	ScrollThem+=1
	#	if ScrollThem >= numberTopics:
	#		ScrollThem = 0
	#	Future(openFeed,widget, currentTopic)
	if countTicks >= 45:
		currentTopic+=1
		if currentTopic > (MaxFeeds - 1):
			currentTopic=0
		feedNr=currentTopic
		Future(openFeed,widget, feedNr)
		countTicks = 0

#This gets called everytime our widget is clicked.
def widgetClicked(widget, x, y, button):
	global currentTopic, countTicks
	if(x > 5) and (x < 22) and (y > 2) and (y < 19):
        	currentTopic-=1
		if currentTopic < 0:
			currentTopic= (MaxFeeds - 1)
		feedNr=currentTopic
		countTicks = 0
		Future(openFeed,widget, feedNr)
	elif (x > 78) and (x < 95) and (y > 2) and (y < 19):
       		currentTopic+=1
		if currentTopic > (MaxFeeds - 1 ):
			currentTopic=0
		feedNr=currentTopic
		countTicks = 0
		Future(openFeed,widget, feedNr)	

def meterClicked(widget, meter, button):
	global currentTopic
	try:
		i = feedSlots.index(meter)
	except ValueError:
		try:
			i = topicSlots.index(meter)
			showTopicPreview(widget, i)
			currentTopic = i
		except ValueError:
			if meter == previewCloseImg:
				hidePreviewBox(widget)			
			elif meter == previewOpenImg:
				openCurrentTopic(widget)
				hidePreviewBox(widget)
			else:
				pDebug('Don\'t know what to do.')

class feed:
	def __init__ (self, displayed, source, name):
		self.displayed = displayed
		self.source    = source
		self.name      = name

	def fetchTopics(self, amount):
		self.topics = []
		channel = feedparser.parse(self.source)
		i = 0;
		for item in channel['items']:
			if amount == 0 or i < amount:
				e = channel['items'][i]
				try:
					tmp = e ['description']
				except TypeError:
					tmp = e ['content_encoded'] 
				self.topics.append([e['title'], e['link'], tmp])
			i+=1
	displayed  = False
	topics     = []
	source     = ""
	name	   = ""
	lastupdate = 0

# Python Wraps the Text and uncaps it all
def wrap(source, nrCols, nrLines):
	out  =''
	## Clean it and wrap it
	source = textwrap.dedent(source)
	source = string.replace(source, '\n', '')
	wrapped = textwrap.fill(source, nrCols)
	#Cut off extra lines
	j = string.count(wrapped, '\n')
	i = string.rfind(wrapped, '\n')
	if j > 1:
		while j > (nrLines-1):
			i = string.rfind(wrapped, '\n')
			wrapped = string.strip(wrapped[0:(i)])
			j = string.count(wrapped, '\n')
	out = wrapped
	return out

# Prints a debug message when in debug mode
def pDebug(str):
	if debug > 0:
		print str
	pass

# Show the topics of a given feed
def openFeed(widget, feedNr):
	global previewText, numberTopics, oldFeed, ScrollThem
	for slot in topicSlots:
		karamba.changeText(widget, slot, '')
	for feed in feeds:
		feed.displayed = False
	karamba.changeText(widget, oldFeed, wrap(feedNames[feedNr],14,2))
	feeds[feedNr].displayed = True
	feeds[feedNr].fetchTopics(numberTopics)
	i = 0
	for topic in feeds[feedNr].topics:
		karamba.changeText(widget, topicSlots[i-ScrollThem], string.capitalize(string.lower(wrap(topic[0], 16, 3))))
		i+=1

# Shows preview box and it's buttons
def showPreviewBox(widget):
	karamba.resizeWidget(widget, 295, 492);
	karamba.showImage(widget, previewCloseImg)
	karamba.showImage(widget, previewOpenImg)
	jannis.showBox(widget, 'preview')
	jannis.popupBox(widget, 'preview', previewBoxW, previewBoxH)

# Hides preview box and it's buttons
def hidePreviewBox(widget):
	karamba.hideImage(widget, previewCloseImg)
	karamba.hideImage(widget, previewOpenImg)
	karamba.changeText(widget, previewText, '')
	jannis.minimizeBox(widget, 'preview')
	jannis.hideBox(widget, 'preview')
	karamba.resizeWidget(widget, 100, 492);

# Shows a preview for a given topic
def showTopicPreview(widget, topicNr):
	global previewText, currentTopic, topicstay
	karamba.changeText(widget, previewText, '')
	topicstay=[]
	for feed in feeds:
		if feed.displayed == True:
			tmp = jannis.getBox(widget, 'preview')
			if len(feed.topics) > topicNr:
				showPreviewBox(widget)
				karamba.changeText(widget, previewText, (wrap(jannis.unHTML(feed.topics[topicNr][2]), previewCols, previewRows)+'\n[...]'))
			topicstay = feed.topics[topicNr][1]

# Opens a browser with the current topic
def openCurrentTopic(widget):
	global topicstay
	try:
		openURL(topicstay)
	except TypeError:
		pDebug("Can't open topic ")

# Opens a URL in firefoxs
def openURL(url):
	karamba.execute("/usr/bin/firefox " + url)

def CreateSelRssCmd (title, description, countLines):
   widget = 1
   cmdResult = ["kdialog", "--title", title, "--radiolist", description]
   items = 0
   show = 1
   counter = -1

   try:
     conffile = open(themepath + '/url.conf', 'r')
   except IOError:
     return None;
   while 1:
     if (countLines == 1): counter = counter + 1
     line = conffile.readline()
     if not line:
       break
     elif line.startswith('\n'):
       continue
     elif line.startswith('#'):
       continue
     else:
       if show:
          if (countLines == 1): cmdResult.append(str(counter))
          else: cmdResult.append(str(items))
          cmdResult.append(line.strip('\n'))
          cmdResult.append("0")
          items = items + 1
          show = 0
       else:
          show = not show
   conffile.close ()
   return cmdResult

#This gets called when an item is clicked in the theme CONFIGURATION menu,
def menuOptionChanged(widget, key, value):
    global pidNewRssTitle, pidNewRssSource, pidDelRssSource

    pidNewRssTitle = None
    pidNewRssSource = None
    pidDelRssSource = None

    if (key == "newRssItem"):
        cmdAddSourceTitle = ["kdialog", "--title", "Add a newssource [title]", "--inputbox", "Please enter the tile for the source :"]
        karamba.setMenuConfigOption (widget, "newRssItem", 0)
        pidNewRssTitle = karamba.executeInteractive(widget, cmdAddSourceTitle)
    elif (key == "delRssItem"):
        cmdDelRssSource = CreateSelRssCmd ("Select an item", "Choose the news item you wish to delete :", 1)
        karamba.setMenuConfigOption(widget, "delRssItem", 0)
        if (cmdDelRssSource == None): return
        pidDelRssSource= karamba.executeInteractive(widget, cmdDelRssSource)

def commandOutput(widget, pid, output):
    global pidNewRssTitle, pidNewRssSource, pidDelRssSource, s, last_get, rss_title
    global textcolor
    newIndex = 0
    if pid == pidNewRssTitle:
        if not output.replace('\n',''):
                print "Cancelled"
        else:
                conffile = open(themepath + '/url.conf', 'a')
                conffile.write (output)
                conffile.close ()
                cmdAddSourceUrl = ["kdialog", "--title", "Add a newssource [url]", "--inputbox", "Please enter the url of the rss file :"]
                pidNewRssSource = karamba.executeInteractive(widget, cmdAddSourceUrl)
    elif pid == pidNewRssSource:
        if not output.replace('\n',''):
          print "Cancelled"
          try:
            conffile = open(themepath + '/url.conf', 'r')
          except IOError:
            return None;
          lstItems = conffile.readlines ()
          del lstItems [len (lstItems) -1]
          conffile.close ()
          try:
            conffile = open(themepath + '/url.conf', 'w')
          except IOError:
            return None;
          conffile.writelines (lstItems)
        else:
          conffile = open(themepath + '/url.conf', 'a')
          conffile.write (output)
          conffile.close ()
	karamba.reloadTheme(widget)
    elif pid == pidDelRssSource:
        strDelIndex = output.replace('\n','')
        if not strDelIndex:
            print "Cancelled"
        else:
          delIndex = int (strDelIndex)
          try:
            conffile = open(themepath + '/url.conf', 'r')
          except IOError:
            return None;
	  lstItems = conffile.readlines ();
          del lstItems [delIndex]
          del lstItems [delIndex]
          conffile.close ()
          try:
            conffile = open(themepath + '/url.conf', 'w')
          except IOError:
            return None;
          conffile.writelines (lstItems)
          if (s > len (lstItems) - 1): s = s - 1
          if (s < 0): s = 0
          last_get = 0
	karamba.reloadTheme(widget)
